# команды

#  nop
^\s*(nop)\s*(#.*)?$

#  halt
^\s*(halt)\s*(#.*)?$

#  rrmovq %rax , %r14
#  rrmovq %r9, %r13
#  rrmovq %r14 , %r8
#  rrmovq %rdx , %rbx
#^\s*(rrmovq)\s+%r(ax|cx|dx|bx|sp|bp|si|di|8|9|10|11|12|13|14)\s*,\s*%r(ax|cx|dx|bx|sp|bp|si|di|8|9|10|11|12|13|14)\s*(#.*)?$
#^\s*(rrmovq)\s+%r(ax|cx|dx|bx|sp|bp|si|di|[8-9]|1[0-4])\s*,\s*%r(ax|cx|dx|bx|sp|bp|si|di|8|9|10|11|12|13|14)\s*(#.*)?$
#^\s*(rrmovq)\s+%r(ax|cx|dx|bx|sp|bp|si|di|[8-9]|1[0-4])\s*,\s*%r(ax|cx|dx|bx|sp|bp|si|di|[8-9]|1[0-4])\s*(#.*)?$
^\s*(rrmovq)\s+%r([a|c|d|b]x|sp|bp|si|di|[8-9]|1[0-4])\s*,\s*%r([a|c|d|b]x|sp|bp|si|di|[8-9]|1[0-4])\s*(#.*)?$

#  irmovq array , %rdx
#  irmovq $4 , %r11
#  irmovq $-10 , %r8
#^\s*(irmovq)\s+(\w+|\$[\+|\-]?[0-9]+|\$0x[0-9|a-f]+)\s*,\s*%e(ax|cx|dx|bx|sp|bp|si|di|8|9|10|11|12|13|14)\s*(#.*)?$
#^\s*(irmovq)\s+(\w+|\$[\+|\-]?[0-9]+|\$0x[0-9|a-f]+)\s*,\s*%r(ax|cx|dx|bx|sp|bp|si|di|[8-9]|1[0-4])\s*(#.*)?$
^\s*(irmovq)\s+(\w+|\$[\+|\-]?[0-9]+|\$0x[0-9|a-f]+)\s*,\s*%r([a|c|d|b]x|sp|bp|si|di|[8-9]|1[0-4])\s*(#.*)?$

#  rmmovq  %rcx , -3(%rbx)
#  rmmovq %rsp, 0x12345 (%rdx)
^\s*(rmmovq)\s+%r([a|c|d|b]x|sp|bp|si|di|[8-9]|1[0-4])\s*,\s*([\+|\-]?[0-9]+|0x[0-9|a-f]+)*\s*\(\s*%r([a|c|d|b]x|sp|bp|si|di|[8-9]|1[0-4])\s*\)\s*(#.*)?$

#  mrmovq (%r11), %rax
#  mrmovq 8(%rbp), %r13  
#  mrmovq -12(%rbp), %rdx  
#  mrmovq 0xf012( %rax ) , %rbx
#^\s*(mrmovq)\s+([\+|\-]?[0-9]+|0x[0-9|a-f]+)*\s*\(\s*%r(ax|cx|dx|bx|sp|bp|si|di|8|9|10|11|12|13|14)\s*\)\s*,\s*%r(ax|cx|dx|bx|sp|bp|si|di|8|9|10|11|12|13|14)\s*(#.*)?$
^\s*(mrmovq)\s+([\+|\-]?[0-9]+|0x[0-9|a-f]+)*\s*\(\s*%r([a|c|d|b]x|sp|bp|si|di|[8-9]|1[0-4])\s*\)\s*,\s*%r([a|c|d|b]x|sp|bp|si|di|[8-9]|1[0-4])\s*(#.*)?$

#  addq %r11, %rbx
#^\s*(addq)\s+%e(ax|cx|dx|bx|sp|bp|si|di|8|9|10|11|12|13|14)\s*,\s*%e(ax|cx|dx|bx|sp|bp|si|di|8|9|10|11|12|13|14)\s*(#.*)?$
#^\s*(addq)\s+%e(ax|cx|dx|bx|sp|bp|si|di|8|9|10|11|12|13|14)\s*,\s*%e(ax|cx|dx|bx|sp|bp|si|di|8|9|10|11|12|13|14)\s*(#.*)?$
^\s*(addq)\s+%r([a|c|d|b]x|sp|bp|si|di|[8-9]|1[0-4])\s*,\s*%r([a|c|d|b]x|sp|bp|si|di|[8-9]|1[0-4])\s*(#.*)?$

#  subq %rax , %r8
^\s*(subq)\s+%r([a|c|d|b]x|sp|bp|si|di|[8-9]|1[0-4])\s*,\s*%r([a|c|d|b]x|sp|bp|si|di|[8-9]|1[0-4])\s*(#.*)?$

#  andq  %rax , %r8
^\s*(andq)\s+%r([a|c|d|b]x|sp|bp|si|di|[8-9]|1[0-4])\s*,\s*%r([a|c|d|b]x|sp|bp|si|di|[8-9]|1[0-4])\s*(#.*)?$

#  xorq  %rax , %r8
^\s*(xorq)\s+%r([a|c|d|b]x|sp|bp|si|di|[8-9]|1[0-4])\s*,\s*%r([a|c|d|b]x|sp|bp|si|di|[8-9]|1[0-4])\s*(#.*)?$

#  cmovle %rax , %r8
^\s*(cmovle)\s+%r([a|c|d|b]x|sp|bp|si|di|[8-9]|1[0-4])\s*,\s*%r([a|c|d|b]x|sp|bp|si|di|[8-9]|1[0-4])\s*(#.*)?$

#  cmovl  %rax , %r8
^\s*(cmovl)\s+%r([a|c|d|b]x|sp|bp|si|di|[8-9]|1[0-4])\s*,\s*%r([a|c|d|b]x|sp|bp|si|di|[8-9]|1[0-4])\s*(#.*)?$

#  cmove %rax , %r8
^\s*(cmove)\s+%r([a|c|d|b]x|sp|bp|si|di|[8-9]|1[0-4])\s*,\s*%r([a|c|d|b]x|sp|bp|si|di|[8-9]|1[0-4])\s*(#.*)?$

#  cmovne  %rax , %r8
^\s*(cmovne)\s+%r([a|c|d|b]x|sp|bp|si|di|[8-9]|1[0-4])\s*,\s*%r([a|c|d|b]x|sp|bp|si|di|[8-9]|1[0-4])\s*(#.*)?$

#  cmovge  %rax , %r8
^\s*(cmovge)\s+%r([a|c|d|b]x|sp|bp|si|di|[8-9]|1[0-4])\s*,\s*%r([a|c|d|b]x|sp|bp|si|di|[8-9]|1[0-4])\s*(#.*)?$

#  cmovg  %rax , %r8
^\s*(cmovg)\s+%r([a|c|d|b]x|sp|bp|si|di|[8-9]|1[0-4])\s*,\s*%r([a|c|d|b]x|sp|bp|si|di|[8-9]|1[0-4])\s*(#.*)?$

#  jmp yyyy
^\s*(jmp)\s+(\w+)\s*(#.*)?$

#  jle yyyy
^\s*(jle)\s+(\w+)\s*(#.*)?$

#  jl yyyy
^\s*(jl)\s+(\w+)\s*(#.*)?$

#  je yyyy
^\s*(je)\s+(\w+)\s*(#.*)?$

#  jne yyyy
^\s*(jne)\s+(\w+)\s*(#.*)?$

#  jge yyyy
^\s*(jge)\s+(\w+)\s*(#.*)?$

#  jg yyyy
^\s*(jg)\s+(\w+)\s*(#.*)?$

#  call xxxx
^\s*(call)\s+(\w+)\s*(#.*)?$

#  ret
^\s*(ret)\s*(#.*)?$

#  pushq %rbp
^\s*(pushq)\s+%r([a|c|d|b]x|sp|bp|si|di|[8-9]|1[0-4])\s*(#.*)?$

#  popq %rbp
^\s*(popq)\s+%r([a|c|d|b]x|sp|bp|si|di|[8-9]|1[0-4])\s*(#.*)?$

