#include <iostream>
#include <stdexcept>
#include <cstdint>
using namespace std;

//stdint.h :
//# define INT64_MIN              (-__INT64_C(9223372036854775807)-1)
//# define INT64_MAX              (__INT64_C(9223372036854775807))
//# define UINT64_MAX             (__UINT64_C(18446744073709551615))

int main( int argc, char *argv[] ) {
   uint64_t u1 = UINT64_MAX - 3, u2 = 3;
   int64_t i1 = INT64_MAX - 3, i2 = INT64_MIN + 3;
   for( int i = 1; i < 4; i++ ) {
      cout << "i=" << i << " "; 
      try { 
         u1 += i; 
         u2 -= i;
         i1 += i;
         i2 -= i;
      }
      catch( runtime_error const& e ) {
//      catch( overflow_error const& e ) {
//      catch(...) { 
         cout << "overflow_error "; 
      }
      cout << "| u1+=" << u1 << " | u2-=" << u2 << " | i1+=" << i1 << " | i2-=" << i2 << " |" <<endl;
   }      
}

